Unit Controls;

{ WolfEnstein clone - with 3D Texture mapping

Copyright (C) 1997-99 TothPaul@multimania.com
 http://www.multimania.com/tothpaul

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}
Interface

{$DEFINE KEYBOARD}

Uses
 Dos;

Const
 key_esc  =01;

 key_ctrl =29;
 key_alt  =56;
 key_del  =83;

 key_up   =72;
 key_left =75;
 key_right=77;
 key_down =80;

 key_prev =73;
 key_next =81;

 key_home =71;
 key_end  =79;



Var
 Done:boolean;
 Turn:Integer;
 Speed:Integer;
 Keyboard:array[0..128] of boolean;

Procedure InitControls;
Procedure CheckControls;
Procedure NoSpeed;

Implementation

{$IFNDEF KEYBOARD}
Function Keypressed:boolean; assembler;
 asm
  mov es,Seg0040
  mov ax,es:[1Ah]
  sub ax,es:[1Ch]
  or  al,ah
 end;
{$ENDIF}

{ Mouse support }
Var
 DeltaX,DeltaY:integer;
 Buttons:set of (btLeft,btRight,btMiddle);
 MouseSpeed:integer;
 GotMouse:word;

Procedure InitMouse; assembler;
 asm
  xor ax,ax
  mov DeltaX ,ax
  mov DeltaY ,ax
  mov Buttons,al
  mov MouseSpeed,ax
  int 33h
  inc ax { $FFFF+1 = 0 }
  mov GotMouse,ax
 end;

Procedure CheckMouse; assembler;
 asm
  mov ax,0Bh    { Get Mouse Move }
  int 33h
  mov DeltaX,cx
  mov DeltaY,dx

  mov ax,03h    { Get Buttons }
  int 33h
  mov Buttons,BL
 end;

{ Keyboard Support }
Var
 Int09:pointer;
 Key:ShortInt;

 TurnLeft :Integer;
 TurnRight:Integer;
 KeyTurn  :Integer;

 SpeedUp  :Integer;
 SpeedDown:Integer;
 KeySpeed :Integer;

Procedure KeyboardHandler; interrupt;
 Var
  Dummy:byte;
 begin
  Byte(Key):=Port[$60];

  dummy:=Port[$61];
  Port[$61]:=dummy or $80;
  Port[$61]:=dummy;

  KeyBoard[Key and $7F]:=(Key>0);

  if Keyboard[key_esc] then Done:=true;

  Port[$20]:=$20;

  if  keyboard[key_del]
  and keyboard[key_ctrl]
  and keyboard[key_alt] then begin
   asm mov ax,03h; int 10h end;
   writeln('Keep cool !');
   halt;
  end;

 end;

Var
 OldExit:pointer;

Procedure DoneKeyboard; far;
 begin
  ExitProc:=OldExit;
  SetIntVec($09,Int09);
 end;

Procedure InitKeyBoard;
 begin
  Fillchar(KeyBoard,SizeOf(KeyBoard),False);
  TurnLeft :=0;
  TurnRight:=0;
  SpeedUp  :=0;
  SpeedDown:=0;
 {$IFDEF KEYBOARD}
  GetIntVec($09,Int09);
  SetIntVec($09,@KeyboardHandler);
  OldExit :=ExitProc;
  ExitProc:=@DoneKeyboard;
 {$ENDIF}
 end;

{..................}
Const
 JoyA=$10;
 JoyB=$20;
 JoyC=$40;
 JoyD=$80;

Var
 JoyFound   :boolean;

 Joybuttons :byte;
 JoyAX,JoyAY:word;
 JoyBX,JoyBY:word;

 JoyMinX:word;
 JoyMaxX:word;
 JoyMinY:word;
 JoyMaxY:word;

 JoyTurn:integer;
 JoySpeed:integer;

procedure ReadJoystick; assembler; { code from PC64 }
 asm
 cli
  cmp JoyFound,False
  je  @TimeOut
  mov dx,201h
  in  al,dx          { read buttons and idle state }
 jmp @Flush
 @Flush:
  out dx,al         { start measurement }
  xor ah,ah
  mov JoyButtons,al
  and al,00001111b
  mov bl,al         { BL = idle state }
  mov cx,10

  @WaitInit:
   in AL,61h         { wait until counters are on }
  loop @WaitInit

  mov ah,00001111b  { all counters are initially on }
  @Next:
   inc cx            { increment loop counter }
   jz @TimeOut       { timeout at 65536 loops }
   in AL,DX          { read state }
   and AL,00001111b
   xor AL,AH         { AL = bits who have changed }
  jz @Next
   test AL,0001b     { check directions and store loop counter }
   je @NoAX
   mov JoyAX,CX
  @NoAX:
   test AL,0010b
   je @NoAY
   mov JoyAY,CX
  @NoAY:
   test AL,0100b
   je @NoBX
   mov JoyBX,CX
  @NoBX:
   test AL,1000b
   je @NoBY
   mov JoyBY,CX
  @NoBY:
   xor AH,AL         { set new state }
   cmp AH,BL         { idle state reached? }
  jne @Next

 jmp @Return
 @TimeOut:
   mov JoyAX,0
   mov JoyAY,0
   mov JoyBX,0
   mov JoyBY,0
  @Return:
  sti
 end;

Procedure InitJoyStick;
 Var
  Status:byte;
  dx,dy:word;
 begin
  JoyButtons:=$ff;
  JoyMinX:=0;
  JoyMaxX:=0;
  JoyMinY:=0;
  JoyMaxY:=0;

  Status:=Port[$201];
  JoyFound:=(Status=$FC)or(Status=$F0);

  if JoyFound then begin
   ReadJoystick;
   JoyFound:=(JoyAX>0)and(JoyAY>0);
   if JoyFound then begin
    dx:=(5*JoyAX) div 16;
    dy:=(5*JoyAY) div 16;
    JoyMinX:=JoyAX-dx;
    JoyMaxX:=JoyAX+dx;
    JoyMinY:=JoyAY-dy;
    JoyMaxY:=JoyAY+dy;
   end;
  end;

 end;

{..................}

Procedure InitControls;
 begin
  InitMouse;
  InitKeyBoard;
  InitJoystick;
  Done:=False;
 end;

Procedure CheckControls;
 begin
 { KEYBOARD }
  if Keyboard[key_left] then Inc(TurnLeft) else TurnLeft:=0;
  if KeyBoard[key_right] then Inc(TurnRight) else TurnRight:=0;
  KeyTurn:=TurnLeft-TurnRight;

  if Keyboard[key_up] then inc(SpeedUp) else SpeedUp:=0;
  if Keyboard[key_Down] then inc(SpeedDown) else SpeedDown:=0;
  KeySpeed:=SpeedUp-SpeedDown;

 { MOUSE }
  if GotMouse=0 then begin
   CheckMouse;

   if Buttons=[] then MouseSpeed:=0 else begin
    if btLeft  in Buttons then inc(MouseSpeed);
    if btRight in Buttons then dec(MouseSpeed);
   end;
  end;

 { JOYSTICK }
  If JoyFound then begin
   ReadJoystick;
   If JoyAX<JoyMinX then Inc(JoyTurn) else
   if JoyAX>JoyMaxX then Dec(JoyTurn) else
   if (JoyButtons and JoyA)=0 then Inc(JoyTurn) else
   if (JoyButtons and JoyD)=0 then Dec(JoyTurn) else JoyTurn:=0;

   if JoyAY<JoyMinY then inc(JoySpeed) else
   if JoyAY>JoyMaxY then dec(JoySpeed) else
   if (JoyButtons and JoyB)=0 then Inc(JoySpeed) else
   if (JoyButtons and JoyC)=0 then Dec(JoySpeed) else JoySpeed:=0;
  end;

 { RESULT }
  Turn:=KeyTurn-DeltaX div 2+JoyTurn;

  Speed:=MouseSpeed-DeltaY+KeySpeed+JoySpeed;

  {$IFNDEF KEYBOARD}Done:=KeyPressed; {$ENDIF}
 end;

Procedure NoSpeed;
 begin
  MouseSpeed:=0;
  KeySpeed:=0;
  JoySpeed:=0;
 end;

end.