Unit DATA;
{$N+}
interface

const
 gunx=79;
 guny=60;

Type
{

SIDE VEIW OF A WALL:

front ceiling texture..
                      v
  -------------h4-------+
                        |
      wall texture ---> |
                        +--h3-------  <-- back ceiling texture


                        +--h2-------  <-- back floor texture
      wall texture ---> |
                        |
  -------------h1-------+
                    ^
front floor texture.:

}
 TWall =record
  x1,y1,x2,y2 :integer;
  h1,h2,h3,h4 :integer;
  Texture     :integer;
  FrontFloor  :integer;
  FrontCeiling:integer;
  BackFloor   :integer;
  BackCeiling :integer;
  TextureX    :integer;
  TextureY    :integer;
  LeftWall    :integer;
  RightWall   :integer;
  length      :integer;
 end;
 TWalls=array[0..1000] of TWall;

 PWallTexture=^TWallTexture;
 TWallTexture=array[0..127,0..127] of byte;

 PFloorTexture=^TFloorTexture;
 TFloorTexture=array[0..63,0..63] of byte;

 TPalTbl=array[0..254,0..255] of byte;

var
 wallcount:integer;
 playerx  :integer;
 playery  :integer;
 playerz  :integer;
 playera  :byte;
 playerv  :integer;

 walls:^TWalls;

 WallTextures:array[0..9] of PWallTexture;
 FloorTextures:array[0..9] of PFloorTexture;

 palette:array[0..255,0..2] of byte;
 paltbl:^TPalTbl;

 gunbmp:array[0..gunx-1,0..guny-1] of byte;

implementation

var
 bspfile:string;
 f:file;
 bsp:text;

procedure readgun;
 begin
  WriteLn('Loading GUN.BMP');
  assign(f,'GUN.BMP');
  reset(f,1);
  if ioresult<>0 then begin
   writeln('file not found');
   halt;
  end;
  seek(f,$436);
  blockread(f,gunbmp,sizeof(gunbmp));
  if ioresult<>0 then begin
   writeln('invalide GUN.BMP');
   halt;
  end;
  close(f);
 end;

procedure LoadWall(Wall:integer);
 var
  s:string;
 begin
  if WallTextures[Wall]=nil then begin
   s:='WALL00.BMP';
   inc(s[5],Wall div 10);
   inc(s[6],Wall mod 10);
   WriteLn('Loading ',s);
   assign(f,s);
   reset(f,1);
   if ioresult<>0 then begin
    writeln(s,' not found');
    halt;
   end;
   new(WallTextures[Wall]);
   seek(f,$436);
   blockread(f,WallTextures[Wall]^,SizeOf(TWallTexture));
   close(f);
  end;
 end;

procedure LoadFloor(Floor:integer);
 var
  s:string;
 begin
  if FloorTextures[Floor]=nil then begin
   s:='FLOOR00.BMP';
   inc(s[6],Floor div 10);
   inc(s[7],Floor mod 10);
   WriteLn('Loading ',s);
   assign(f,s);
   reset(f,1);
   if ioresult<>0 then begin
    writeln(s,' not found');
    halt;
   end;
   new(FloorTextures[Floor]);
   seek(f,$436);
   blockread(f,FloorTextures[Floor]^,SizeOf(TFloorTexture));
   close(f);
  end;
 end;


procedure readmap;
 var
  i:integer;
  dx,dy:single;
 begin
  readgun;

  assign(bsp,bspfile);
  reset(bsp);
  if ioresult<>0 then begin
   writeln('invalide ',bspfile);
   halt;
  end;
  readln(bsp,wallcount,playerx,playery,playerz,playera);

  playerv:=0;

  getmem(Walls,wallcount*sizeof(TWall));

  fillchar(WallTextures,SizeOf(WallTextures),0);
  fillchar(FloorTextures,SizeOf(FloorTextures),0);

  for i:=0 to wallcount-1 do begin
   with Walls^[i] do begin
    ReadLn(bsp,x1,y1,x2,y2,h1,h2,h3,h4,
               Texture,FrontFloor,FrontCeiling,BackFloor,BackCeiling,
               TextureX,TextureY,
               LeftWall,RightWall);
    LoadWall(Texture);
    LoadFloor(FrontFloor);
    LoadFloor(FrontCeiling);
    LoadFloor(BackFloor);
    LoadFloor(BackCeiling);
    dx:=x2-x1;
    dy:=y2-y1;
    Length:=round(sqrt(dx*dx+dy*dy));
   end;
  end;

  close(bsp);
 end;

procedure readpal;
 var
  i,j,k:integer;
  shade:single;
  r,g,b:single;
  d,d1:single;
  m:integer;
 begin
  assign(f,'TEXTURES.PAL');
  reset(f,1);
  blockread(f,palette,sizeof(palette));
  close(f);

  new(paltbl);

  assign(f,'PALTBL.DAT');
  reset(f,1);
  if ioResult=0 then begin
   writeln('Loading palette');
   blockread(f,paltbl^,sizeof(TPalTbl));
   close(f);
  end else begin
   write('Building palette [');
   write('                ]');
   write(#13,'Building palette [');
   for j:=0 to 254 do begin
    shade:=j/254;
    for i:=0 to 255 do begin
     r:=palette[i,0]*shade;
     g:=palette[i,1]*shade;
     b:=palette[i,2]*shade;
     m:=0;
     d:=3*65535;
     for k:=0 to 255 do begin
      d1:=sqr(r-palette[k,0])+sqr(g-palette[k,1])+sqr(b-palette[k,2]);
      if d1<d then begin d:=d1; m:=k end;
     end;
     paltbl^[j,i]:=m;
    end;
    if (j mod 16)=0 then write('.');
   end;
   writeln;
   rewrite(f,1);
   blockwrite(f,paltbl^,sizeof(TPalTbl));
   close(f);
  end;
 end;


begin
 asm mov ax,03h; int 10h end;
 fillchar(Mem[SegB800:0],2*80,' ');
 writeln(' BP-DOOM (C) 1999 by Paul TOTH <tothpaul@multimania.com>');

 if paramcount=0 then bspfile:='level1' else bspfile:=paramstr(1);
 if bspfile='/?' then begin
  writeln('BPDOOM [filename[.bsp]]');
  halt;
 end;
 FileMode:=0; { Read Only }
 if pos('.',bspfile)=0 then bspfile:=bspfile+'.bsp';
 writeln('Memory : ',memavail);
 writeln('Loading ',bspfile);
 readmap;
 readpal;
 writeln('Memory : ',memavail);
 write('----[ENTER]----');
 readln;
end.